## ros-foxy-ueye-cam 2.0.0

=== CMakeLists.txt ===
##############################################################################
# CMake Configuration
##############################################################################

cmake_minimum_required(VERSION 3.5)
project(ueye_cam)

# Turn -isystem off. Actually like to see warnings from underlying packages
# and regardless, have run into trouble because of the ordering it induces.
set(CMAKE_NO_SYSTEM_FROM_IMPORTED TRUE)

if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(
    -Wall -Wextra -Werror
    # -Wpedantic # warnings in ueye.h block compilation
    # -Wnon-virtual-dtor -Woverloaded-virtual
    # -Wformat=2 -Wconversion -Wshadow -Wsign-conversion
    # -Wold-style-cast -Wcast-qual
  )
endif()

##############################################################################
# Find Packages
##############################################################################

find_package(ament_cmake REQUIRED)
find_package(camera_calibration_parsers REQUIRED)
find_package(camera_info_manager REQUIRED)
find_package(image_transport REQUIRED)
find_package(rcl_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(sensor_msgs REQUIRED)

##############################################################################
# UEye Drivers
##############################################################################

# If you have an official installation of the IDS drivers they will
# be on your system path. Check for that here and if not found, download
# header and library on-the-fly for the build (this won't be made
# available for the runtime environment though).
find_library(UEYE_LIBRARY ueye_api)
find_path(UEYE_INCLUDE_DIR ueye.h)
if(UEYE_LIBRARY)
  message(STATUS "Found 'official' ueye_drivers")
  option(UEYE_FOUND 1)
else(UEYE_LIBRARY)
  include(cmake_modules/DownloadUEyeDriversUnofficial.cmake)
  download_ueye_drivers(UEYE_LIBRARY UEYE_INCLUDE_DIR ${UEYE_DRIVER_DIR})
endif()
message(STATUS "  UEYE_FOUND: ${UEYE_FOUND}")
message(STATUS "  UEYE_LIBRARY: ${UEYE_LIBRARY}")
message(STATUS "  UEYE_INCLUDE_DIR: ${UEYE_INCLUDE_DIR}")

##############################################################################
# Ament
##############################################################################

# Populate ${PROJECT_NAME}_VERSION from xml
# Useful for setting version suffixes on libraries.
ament_package_xml()

##############################################################################
# Sources
##############################################################################

add_subdirectory(include)
add_subdirectory(src)

##############################################################################
# Data Resources
##############################################################################

install(
  DIRECTORY
    config
    launch
  DESTINATION share/${PROJECT_NAME}
)

##############################################################################
# Components
##############################################################################

# This macro only works, when in the project's root CMakeLists.txt. When
# used in a nested CMakeLists.txt, the markers failed to be installed in
# share/ament_index/resource_index/rclcpp_components/ueye_cam
rclcpp_components_register_nodes(${PROJECT_NAME}_ros "ueye_cam::Node")

##############################################################################
# Exports
##############################################################################

# Modern CMake (CMake3) exports
# ament_export_interfaces(HAS_LIBRARY_TARGET ${PROJECT_NAME}) # Dashing
ament_export_targets(HAS_LIBRARY_TARGET ${PROJECT_NAME})  # Foxy+

# CMake2 exports
ament_export_include_directories(include)
ament_export_dependencies(
  camera_calibration_parsers
  camera_info_manager
  image_transport
  rcl_interfaces
  rclcpp
  sensor_msgs
)
ament_package()

=== include/CMakeLists.txt ===
###############################################################################
# Subdirectories
###############################################################################

add_subdirectory(ueye_cam)

###############################################################################
# Files
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)

install(FILES ${HEADERS} DESTINATION include)

=== src/CMakeLists.txt ===
###############################################################################
# Subdirectories
###############################################################################

add_subdirectory(driver)
add_subdirectory(ros)
add_subdirectory(applications)

=== include/ueye_cam/CMakeLists.txt ===
###############################################################################
# Files
###############################################################################

file(GLOB HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.hpp)

install(FILES ${HEADERS} DESTINATION include/${PROJECT_NAME})

=== src/applications/CMakeLists.txt ===
###############################################################################
# Find Packages
###############################################################################

find_package(PkgConfig REQUIRED)
pkg_check_modules(TCLAP REQUIRED tclap)

###############################################################################
# Targets
###############################################################################

########################################
# Ueye Installation Check
########################################

add_executable(ueye_installation_check ueye_installation_check.cpp)

target_include_directories(
  ueye_installation_check
  PRIVATE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${TCLAP_INCLUDEDIR}>
)

target_link_libraries(ueye_installation_check
  PRIVATE
    ${CMAKE_DL_LIBS}
)

add_executable(standalone_node standalone_node.cpp)

########################################
# Ueye Driver Check
########################################

add_executable(ueye_driver_check ueye_driver_check.cpp)

target_include_directories(
  ueye_driver_check
  PRIVATE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${TCLAP_INCLUDEDIR}>
)

target_link_libraries(ueye_driver_check
  PRIVATE
    ${PROJECT_NAME}_driver
)

########################################
# ROS2 Standalone Node
########################################

# TODO: on foxy, shift to modern cmake target linking
# https://docs.ros.org/en/foxy/Releases/Release-Foxy-Fitzroy.html#classic-cmake-vs-modern-cmake
ament_target_dependencies(
  standalone_node
    rclcpp
)

target_link_libraries(standalone_node
  ${PROJECT_NAME}_ros
)

###############################################################################
# Install
###############################################################################

install(
  TARGETS
    standalone_node
    ueye_driver_check
    ueye_installation_check
  DESTINATION lib/${PROJECT_NAME}
)

=== src/driver/CMakeLists.txt ===
###############################################################################
# Sources
###############################################################################

file(GLOB SOURCES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.cpp)

###############################################################################
# Targets
###############################################################################
   
add_library(${PROJECT_NAME}_driver SHARED ${SOURCES})

target_include_directories(
  ${PROJECT_NAME}_driver
  PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${UEYE_INCLUDE_DIR}>
    $<INSTALL_INTERFACE:include>
)

# When building with the fetched on-the-fly headers and libraries, make sure
# not to export the directories (which happen to be in the build folder).
# CMake will complain if you try and do this.
#
# Caveat: this does rely on downstream targets outside of this package
# being able to find the headers and libraries in system paths.
if(UEYE_FOUND)
  target_include_directories(
    ${PROJECT_NAME}_driver
    PUBLIC
      $<INSTALL_INTERFACE:${UEYE_INCLUDE_DIR}>
  )
endif()

target_link_libraries(
  ${PROJECT_NAME}_driver
  PUBLIC
    ${UEYE_LIBRARY}
)

set_target_properties(
  ${PROJECT_NAME}_driver
  PROPERTIES
    SOVERSION ${${PROJECT_NAME}_VERSION}
    VERSION ${${PROJECT_NAME}_VERSION}
)

###############################################################################
# Install
###############################################################################

install(TARGETS ${PROJECT_NAME}_driver EXPORT ${PROJECT_NAME}
   RUNTIME DESTINATION bin
   ARCHIVE DESTINATION lib
   LIBRARY DESTINATION lib
)

=== src/ros/CMakeLists.txt ===
###############################################################################
# Targets
###############################################################################

add_library(${PROJECT_NAME}_ros SHARED node.cpp)

target_include_directories(
  ${PROJECT_NAME}_ros
  INTERFACE
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)

# TODO: on foxy, shift to modern cmake target linking
# https://docs.ros.org/en/foxy/Releases/Release-Foxy-Fitzroy.html#classic-cmake-vs-modern-cmake
ament_target_dependencies(
  ${PROJECT_NAME}_ros
    camera_calibration_parsers
    # camera_info_manager
    image_transport
    rclcpp
    rclcpp_components
    sensor_msgs
)

# Modern CMake Linking
target_link_libraries(${PROJECT_NAME}_ros
    ${PROJECT_NAME}_driver
)

set_target_properties(${PROJECT_NAME}_ros
  PROPERTIES
    SOVERSION ${${PROJECT_NAME}_VERSION}
    VERSION ${${PROJECT_NAME}_VERSION}
)

###############################################################################
# Install
###############################################################################

install(
  TARGETS
    ${PROJECT_NAME}_ros
  EXPORT ${PROJECT_NAME}
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
)

=== debian/changelog ===
ros-foxy-ueye-cam (2.0.0-1focal) focal; urgency=high

  * ros2 port for Foxy
  * export IDS configuration files
  * Contributors: jmackay2, stonier

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Fri, 25 Jun 2021 04:00:00 -0000

ros-foxy-ueye-cam (1.0.19-1focal) focal; urgency=high

  * updated MD5 hash for re-packaged unofficiall IDS drivers archives
  * Contributors: Anqi Xu

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Wed, 13 Jan 2021 05:00:00 -0000

ros-foxy-ueye-cam (1.0.18-1focal) focal; urgency=high

  * updated driver URLs for 4.94 version
  * [uEye 4.94] Update Deprecated Event Handling Functions  (#97 <https://github.com/anqixu/ueye_cam/issues/97>)
    * Updated event functions to 4.94 API + Added init of event before enabling it
    * Added uEye 4.94 req
    * Changed timeout to UINT to fit 4_94 API
  * Adding call of exit routine for the frame event
  * Adding auto exposure reference value
  * Added support for setting the software-gamma
  * Package format update and code cleanup
  * Contributors: Anqi Xu, Brett Newman, Nullket, jmackay2, nullket

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Sat, 09 Jan 2021 05:00:00 -0000

ros-foxy-ueye-cam (1.0.17-1focal) focal; urgency=high

  * Merge pull request #83 <https://github.com/anqixu/ueye_cam/issues/83> from anqixu/use_ros_time
    Do not get timestamp from camera, and use ros::Time::now() instead
  * Merge pull request #61 <https://github.com/anqixu/ueye_cam/issues/61> from jackokaiser/master
    Adapted roslaunch for passing camera name as argument
  * Changes from https://github.com/anqixu/ueye_cam/issues/82
  * Do not link the ueye api to the check api node to avoid conflicts
  * Default dynamic_reconfigure parameters now don't overwrite ini file params.
    Fixes #74 <https://github.com/anqixu/ueye_cam/issues/74>
  * image dimensions now account for cam_subsampling_rate
  * Merge pull request #65 <https://github.com/anqixu/ueye_cam/issues/65> from flynneva/dev
  * removed / from frame_ID so that data can be used with new ros tf2 standard
  * Removed trailing whitespaces
  * Readded camera_conf for backward compatibility
  * changed setFlashParams failure into warning
  * Adapted roslaunch for passing camera name as argument
  * nodelet no longer dies upon setFlashParams fail (since some cameras don't support it)
  * Merge pull request #54 <https://github.com/anqixu/ueye_cam/issues/54> from 534o/master
  * forget to add check_ueye_api to install list
  * Contributors: Anqi Xu, Anup Parikh, Evan Flynn, Jacques KAISER, Tokyo Opensource Robotics Developer 534, loooph

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Wed, 26 Aug 2020 04:00:00 -0000

ros-foxy-ueye-cam (1.0.16-1focal) focal; urgency=high

  * fixed crash on camera reconnect
  * Contributors: Anqi Xu, Christopher Wecht

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 02 Jan 2017 05:00:00 -0000

ros-foxy-ueye-cam (1.0.15-1focal) focal; urgency=high

  * recover + update from failure in setColorMode
  * extended color modes (10, 12, 16 bit per channel)
  * added timeout topic for better debugging of frame timeouts
  * Contributors: Anqi Xu, Dominik Klein

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 25 Aug 2016 04:00:00 -0000

ros-foxy-ueye-cam (1.0.14-1focal) focal; urgency=high

  * now attempting to link against 32-bit ARMHF IDS libs on ARM64 arch
  * added capability to detect ARM64 processor (aarch64)
  * added separate rates for polling frames vs publishing images
  * fixed buffersize for subsampling and increased maximum image size availible via rqt
  * added Travis CI config
  * Contributors: Anqi Xu, Eddy, Isaac I.Y. Saito, francois

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 26 May 2016 04:00:00 -0000

ros-foxy-ueye-cam (1.0.13-1focal) focal; urgency=high

  * Change timestamp source based on issue https://github.com/anqixu/ueye_cam/issues/37
  * changed 'failure to set active-low flash' from error to warning
  * Fixed typo in Gain for dynamic reconfigure parameters
  * Updated pixel_clock cap in dyncfg settings
  * Added check_ueye_api to confirm availability of IDS SDK at runtime
  * Contributors: Anqi Xu, Anup, Aris Synodinos, Kei Okada

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Fri, 13 May 2016 04:00:00 -0000

ros-foxy-ueye-cam (1.0.12-1focal) focal; urgency=high

  * fixed binning IS_INVALID_BUFFER_SIZE bug
  * Modified nodelet to use camera timestamp instead of wall clock time
  * Fix for new upstream dir name on ARM
  * Contributors: Alejandro Merello, Anqi Xu, Scott K Logan

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 28 Sep 2015 04:00:00 -0000

ros-foxy-ueye-cam (1.0.11-1focal) focal; urgency=high

  * updated barebones IDS drivers to 4.61
  * removed barebones IDS drivers from debian packaging
  * Added proper checking for C++11 features on compilers
  * Performed minor code cleanup, updated old PLUGINLIB_DECLARE_CLASS to
    newer PLUGINLIB_EXPORT_CLASS
  * Contributors: Anqi Xu, Aris Synodinos

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Mon, 17 Aug 2015 04:00:00 -0000

ros-foxy-ueye-cam (1.0.10-1focal) focal; urgency=high

  * fixed setting synchronization bugs during camera initialization
  * added support for (packed) BGR8 color mode
  * failing to set non-essential parameters will no longer prematurily terminate nodelet
  * updated printouts to be more verbose and consistent
  * fix for reported ARM arch on Fedora
  * Contributors: Anqi Xu, Scott K Logan

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Thu, 06 Aug 2015 04:00:00 -0000

ros-foxy-ueye-cam (1.0.9-1focal) focal; urgency=high

  * fixed lagged changes to flip_upd and flip_lr via rqt_reconfigure
  * Support discrete-only pixelclocks cameras
  * Ask if gainboost is supported first
  * Switched to jbohren's version of the file(GENERATE...) fix
  * Contributors: Anqi Xu, Fran Real, Jonathan Bohren

 -- Anqi Xu <anqixu@cim.mcgill.ca>  Tue, 03 Feb 2015 05:00:00 -0000

ros-foxy-ueye-cam (1.0.8-1focal) focal; urgency=high

  * switched from cmake's file(GENERATE ...) to execute_command(cp ...), to accommodate cmake 2.8.x on Saucy
  * Contributors: Anqi Xu



=== debian/control ===
Source: ros-foxy-ueye-cam
Section: misc
Priority: optional
Maintainer: Anqi Xu <anqixu@cim.mcgill.ca>
Build-Depends: debhelper (>= 9.0.0), libtclap-dev, ros-foxy-ament-cmake, ros-foxy-ament-lint-auto, ros-foxy-ament-lint-common, ros-foxy-camera-calibration-parsers, ros-foxy-camera-info-manager, ros-foxy-image-transport, ros-foxy-rcl-interfaces, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-sensor-msgs, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-ueye-cam
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-index-python, ros-foxy-camera-calibration-parsers, ros-foxy-camera-info-manager, ros-foxy-image-transport, ros-foxy-launch, ros-foxy-launch-ros, ros-foxy-rcl-interfaces, ros-foxy-rclcpp, ros-foxy-rclcpp-components, ros-foxy-sensor-msgs, ros-foxy-ros-workspace
Description: A ROS node that wraps the driver API for UEye cameras by IDS Imaging Development Systems GMBH.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-ueye-cam//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
